(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else if(typeof exports === 'object')
		exports["ReduxModifiers"] = factory();
	else
		root["ReduxModifiers"] = factory();
})(this, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};

/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {

/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;

/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};

/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);

/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;

/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}


/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;

/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;

/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";

/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	exports.object = exports.set = exports.array = exports.target = undefined;
	exports.update = update;

	var _target2 = __webpack_require__(4);

	var _target3 = _interopRequireDefault(_target2);

	var _arrays = __webpack_require__(2);

	var _array = _interopRequireWildcard(_arrays);

	var _sets = __webpack_require__(3);

	var _set = _interopRequireWildcard(_sets);

	var _objects = __webpack_require__(1);

	var _object = _interopRequireWildcard(_objects);

	function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	exports.target = _target3.default;

	/**
	 * Update complex data types
	 */
	/**
	 * Target specific parts of state
	 */

	exports.array = _array;
	exports.set = _set;
	exports.object = _object;

	/**
	 * Update targeted scalar data type, or replace entire state tree
	 */

	function update(state, action) {
	  var payload = action.payload;

	  return payload;
	}

/***/ },
/* 1 */
/***/ function(module, exports) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

	exports.update = update;
	exports.updateWhere = updateWhere;
	exports.remove = remove;
	exports.containsMatches = containsMatches;
	/**
	 * Iterate over an object and replace values of keys present in payload
	 */
	function update(state, action) {
	  var payload = action.payload;


	  if ((typeof payload === 'undefined' ? 'undefined' : _typeof(payload)) != 'object') throw new Error('payload must be an object!');

	  var updated = Object.assign({}, state, payload);
	  return updated;
	}

	/**
	 * Iterate over object and make updates where matches
	 */
	function updateWhere(state, action) {
	  var payload = action.payload;
	  var where = payload.where;
	  var updates = payload.updates;


	  if (!where || !updates) throw new Error('"where" and "updates" keys must be present in updateWhere.');

	  var copy = Object.assign({}, state);
	  for (var key in copy) {
	    var item = copy[key];

	    if (containsMatches(item, where)) {
	      copy[key] = update(item, { payload: updates });
	    }
	  }

	  return copy;
	}

	/**
	 * Remove a specific key
	 */
	function remove(state, action) {
	  var payload = action.payload;


	  var err = function err() {
	    throw new Error('Key must be a string!');
	  };

	  var type = typeof payload === 'undefined' ? 'undefined' : _typeof(payload);

	  var isArray = Array.isArray(payload);
	  if (type != 'string' && !isArray) {
	    err();
	  }

	  var omit = {};
	  if (isArray) {
	    for (var i = 0; i < payload.length; i++) {
	      omit[payload[i]] = true;
	    }
	  } else {
	    omit[payload] = true;
	  }

	  var copy = {};
	  for (var key in state) {
	    if (!omit[key]) copy[key] = state[key];
	  }

	  return copy;
	}

	/**
	 * Check if an object matches some arguments, i.e:
	 *
	 * does {foo: 'bar', id: 1} match {id: 1}
	 */
	function containsMatches(object, where) {
	  for (var key in where) {
	    if (object[key] != where[key]) return false;
	  }

	  return true;
	}

/***/ },
/* 2 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	exports.add = add;
	exports.updateByIndex = updateByIndex;
	exports.updateWhere = updateWhere;
	exports.removeAtIndex = removeAtIndex;
	exports.removeEqualTo = removeEqualTo;
	exports.clear = clear;

	var _objects = __webpack_require__(1);

	/**
	 * Add item to array
	 */
	function add(state, action) {
	  var payload = action.payload;


	  if (!payload) throw new Error('No payload received by arrayPush! Did your action include a payload?');

	  return state.concat(payload);
	}

	/**
	 * Update array value by index
	 */
	function updateByIndex(state, action) {
	  var payload = action.payload;
	  var index = payload.index;
	  var item = payload.item;


	  return state.slice(0, index).concat(item).concat(state.slice(index + 1));
	}

	/**
	 * Update objects in array where equal to
	 *
	 * TODO: support arrays in where check, i.e. update where ['foo', 'bar']
	 */
	function updateWhere(state, action) {
	  var payload = action.payload;
	  var updates = payload.updates;
	  var where = payload.where;


	  if (!where || !updates) throw new Error('"where" and "updates" keys must be present in updateWhere.');

	  var copy = state.concat();

	  for (var i = 0; i < copy.length; i++) {
	    var item = copy[i];
	    if ((0, _objects.containsMatches)(item, where)) {
	      copy[i] = (0, _objects.update)(item, { payload: updates });
	    }
	  }

	  return copy;
	}

	/**
	 * Remove an array item at a specific index
	 */
	function removeAtIndex(state, action) {
	  var payload = action.payload;

	  var index = payload;

	  return state.slice(0, index).concat(state.slice(index + 1));
	}

	/**
	 * Remove items from array where value is equal to
	 */
	function removeEqualTo(state, action) {
	  var payload = action.payload;


	  return state.filter(function (item) {
	    return item != payload;
	  });
	}

	/**
	 * Return a blank array
	 */
	function clear(state, action) {
	  return [];
	}

/***/ },
/* 3 */
/***/ function(module, exports) {

	"use strict";

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	exports.add = add;
	exports.remove = remove;
	//Note: Set utils are probably only useful in cases where insertions and deletions are infrequent, but membership tests are very frequent

	/**
	 * Add new items to a set
	 */
	function add(state, action) {
	  var set = new Set(Array.from(state));
	  var payload = action.payload;


	  set.add(payload);
	  return set;
	}

	/**
	 * Remove item from a set
	 */
	function remove(state, action) {
	  var set = new Set(Array.from(state));
	  var payload = action.payload;


	  set.delete(payload);
	  return set;
	}

/***/ },
/* 4 */
/***/ function(module, exports) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

	exports.default = target;
	function select(obj, args) {
	  var res = obj;
	  for (var i = 0; i < args.length; i++) {
	    res = res[args[i]];
	    if (!res) throw new Error(args[i] + ' is not a key!');
	  }
	  return res;
	}

	function assign(obj, args, value) {
	  var res = obj;
	  for (var i = 0; i < args.length - 1; i++) {
	    res = res[args[i]];
	  }
	  var x = args[args.length - 1];
	  res[x] = value;
	}

	function target() {
	  for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
	    args[_key] = arguments[_key];
	  }

	  var func = args.pop();

	  if (typeof func != 'function') throw new Error('last argument to traverse must be a function.');

	  return function (state, action) {
	    if ((typeof state === 'undefined' ? 'undefined' : _typeof(state)) != 'object') throw new Error('state must be an object!');

	    var copy = Object.assign({}, state);
	    var targeted = select(copy, args);
	    var value = func(targeted, action);
	    assign(copy, args, value);

	    return copy;
	  };
	}

/***/ }
/******/ ])
});
;