'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

exports.default = target;
function select(obj, args) {
  var res = obj;
  for (var i = 0; i < args.length; i++) {
    res = res[args[i]];
    if (!res) throw new Error(args[i] + ' is not a key!');
  }
  return res;
}

function assign(obj, args, value) {
  var res = obj;
  for (var i = 0; i < args.length - 1; i++) {
    res = res[args[i]];
  }
  var x = args[args.length - 1];
  res[x] = value;
}

function target() {
  for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
    args[_key] = arguments[_key];
  }

  var func = args.pop();

  if (typeof func != 'function') throw new Error('last argument to traverse must be a function.');

  return function (state, action) {
    if ((typeof state === 'undefined' ? 'undefined' : _typeof(state)) != 'object') throw new Error('state must be an object!');

    var copy = Object.assign({}, state);
    var targeted = select(copy, args);
    var value = func(targeted, action);
    assign(copy, args, value);

    return copy;
  };
}